'use strict';

var _trailShimmer = require('trail-shimmer');

var _trailShimmer2 = _interopRequireDefault(_trailShimmer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = {
    target: 'bluebird/js/main/promise',
    wrap(agent, bluebird) {

        const Bluebird = bluebird();
        _trailShimmer2.default.wrap(Bluebird.prototype, 'Bluebird.prototype', '_addCallbacks', function (original) {
            return function (fulfill, reject, progress, promise, receiver, domain) {
                if (typeof fulfill === 'function') {
                    fulfill = agent.bind(fulfill);
                }
                if (typeof reject === 'function') {
                    reject = agent.bind(reject);
                }
                if (typeof progress === 'function') {
                    progress = agent.bind(progress);
                }

                return original.call(this, fulfill, reject, progress, promise, receiver, domain);
            };
        });

        return function () {
            return Bluebird;
        };
    }
};